<template>
  <a-modal
    title="操作"
    style="top: 20px;"
    :width="800"
    v-model="visible"
    :confirmLoading="confirmLoading"
    @ok="handleSubmit"
  >
    <a-form :form="form">
      <a-form-item style="display:none">
        <a-input v-decorator="['id']" />
      </a-form-item>
      <a-form-item style="display:none">
        <a-input v-decorator="['version']" />
      </a-form-item>
      <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="会议室名称">
        <a-input placeholder="会议室名称"
                 v-decorator="['meetingName',{rules: [{ required: true, message: '请输入会议室名称' }]}]" />
      </a-form-item>
      <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="管理员">
        <a-select show-search mode="multiple"
                  v-decorator="['staffId', {rules: [{ required: true, message: '管理员' }]}]" optionFilterProp="label">
          <a-select-option v-for="item in staffLists" :key="item.id" :label="item.mobile">{{ item.username
            }}--{{ item.mobile }}
          </a-select-option>
        </a-select>
      </a-form-item>
      <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="备注">
        <a-input placeholder="备注" v-decorator="['remake']" />
      </a-form-item>
    </a-form>
  </a-modal>
</template>
<script>
import { saveWisdomRoom, selectStaff } from '@/api/admin/wisdomRoom'
import pick from 'lodash.pick'

export default {
  name: 'WisdomRoomModal',
  props: {},
  components: {},
  data () {
    return {
      visible: false,
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      },
      confirmLoading: false,
      mdl: {},
      staffLists: [],
      form: this.$form.createForm(this)
    }
  },
  beforeCreate () {
  },
  created () {
    this.selectStaffList()
  },
  methods: {
    selectStaffList () {
      selectStaff().then(res => {
          this.staffLists = res.data
      })
    },
    add () {
      this.form.resetFields()
      this.edit({ id: 0 })
    },
    edit (record) {
      this.mdl = Object.assign(record)
      this.visible = true
      this.$nextTick(() => {
        this.form.setFieldsValue(pick(this.mdl, 'id', 'type', 'staffId', 'meetingName', 'startTime', 'endDate', 'createBy', 'createTime', 'updateBy', 'updateTime', 'version', 'deleteFlag', 'remake', 'tenantId', 'parkId'))
      })
    },
    handleSubmit (e) {
      e.preventDefault()
      this.form.validateFields((err, values) => {
        if (!err) {
          console.log('Received values of form: ', values)
          this.confirmLoading = true
          saveWisdomRoom(values).then(res => {
            if (res.code === 0) {
              this.$message.success('保存成功')
              this.$emit('ok')
              this.visible = false
            } else {
              this.$message.error(res.msg)
            }
          }).catch(() => {
            this.$message.error('系统错误，请稍后再试')
          }).finally(() => {
            this.confirmLoading = false
          })
        }
      })
    }
  },
  watch: {
    /*
      'selectedRows': function (selectedRows) {
        this.needTotalList = this.needTotalList.map(item => {
          return {
            ...item,
            total: selectedRows.reduce( (sum, val) => {
              return sum + val[item.dataIndex]
            }, 0)
          }
        })
      }
      */
  }
}
</script>
